<?php
//////////////////////////////////////////////////////

sitemap.xmlの生成とDL処理
・除外ディレクトリがある場合は例にそって処理の修正を行って下さい。
・PHP動くサーバに設置します。アクセスするだけでsitemap.xmlのダウンロードができる！
・外部サイトの一覧は取れない。あくまでも自サイト用で

/////////////////////////////////////////////////////




//---------------------------------
// 基本設定
//---------------------------------
$dir = dirname(__FILE__) . '/';

//---------------------------------
// sitemap生成処理
//---------------------------------
$result = create_sitemap($dir);

//---------------------------------
// sitemap.xmlのダウンロード
//---------------------------------
$fileName = "sitemap.xml";
header('Content-Type: text/plain');
header('Content-Disposition: attachment; filename='.$fileName);
echo $result['sitemap'];
exit;


/***************************************************************
 サイトマップ.xmlの生成
***************************************************************/
function create_sitemap($dir)
{
  //---------------------------------
  //ファイル一覧の取得
  //---------------------------------
  $iterator = new RecursiveIteratorIterator(
    new RecursiveDirectoryIterator(
      $dir,
      FilesystemIterator::SKIP_DOTS
      |FilesystemIterator::KEY_AS_PATHNAME
      |FilesystemIterator::CURRENT_AS_FILEINFO
    ), RecursiveIteratorIterator::LEAVES_ONLY
  );
 
  $list = array('dirData'=>"",'sitemap'=>"");
  $cnt = 0;

  $list['sitemap'] = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  $list['sitemap'].= "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">\n";

  foreach($iterator as $pathname => $info)
  {
    //---------------------------------
    // 除外したいものを記述
    // 下記例では、.htmlファイルで、/test/ディレクトリに属していないファイル
    // の意味となります。
    //---------------------------------
    if(strpos($pathname,'.html') != false 
      && strpos($pathname,'/test/') === false
      )
    {
      //---------------------------------
      // ディレクトリpathからURL形式に変更する
      //---------------------------------
      $list['dirData'][$cnt]['path'] = str_replace("[生ファイルパス(自分で調べて)]", "[自サイトドメイン]",$pathname);

      //---------------------------------
      // ファイルの最終更新日時を取得する
      //---------------------------------
      $list['dirData'][$cnt]['lastmod'] = date("Y-m-d",filemtime($pathname));

      //---------------------------------
      // xml用データの生成
      //---------------------------------
      $list['sitemap'].= "  <url>\n";
        $list['sitemap'].= "    <loc>".$list['dirData'][$cnt]['path']."</loc>\n";
        $list['sitemap'].= "    <lastmod>".$list['dirData'][$cnt]['lastmod']."</lastmod>\n";
      $list['sitemap'].= "  </url>\n";
      $cnt++;
    }
  }

  $list['sitemap'].= "</urlset>";
  return $list;
}

?>